# codegenmain.py - Perform Code Generation with Cheetah

# Copyright (c) 2007-2008, Jason Breti (http://breti.org/codegen)
# All rights reserved.
# This code is released under the BSD License, as specified in the
# license.txt file.

from sm_events_h import sm_events_h
from sm_stateChart_cpp import sm_stateChart_cpp
from sm_state_generic_h import sm_state_generic_h
from sm_state_generic_cpp import sm_state_generic_cpp

from loader import Loader
from generator import Generator

if __name__ == '__main__':
  
  loader = Loader()
  loader.load('./car_alarm.xml')

  generator = Generator()
  
  entireChartFiles = {'./src/sm_events.h':
                        sm_events_h(),
                      './src/sm_stateChart.cpp':
                        sm_stateChart_cpp() }
  
  for fileName in entireChartFiles:
    print 'Generating:', fileName
    generator.generateChart(loader.stateChartXML,
                            fileName,
                            entireChartFiles[fileName])
    
  
  stateFiles = {'.h':   sm_state_generic_h(),
                '.cpp': sm_state_generic_cpp() }

  for extension in stateFiles:
    for stateNode in loader.stateChartXML.getchildren():
      if stateNode.tag == 'state' and \
         'id' in stateNode.attrib:
        fileName = './src/sm_state_' + stateNode.attrib['id'] + extension
        print 'Generating:', fileName
        generator.generateState(loader.stateChartXML,
                                stateNode,
                                fileName,
                                stateFiles[extension])
    


