// Copyright (c) 2007-2008, Jason Breti (http://breti.org/codegen)
// All rights reserved.
// This code is released under the BSD License, as specified in the
// license.txt file.

#include <iostream>

#include "sm_events.h"
#include "sm_stateController.h"

int main (void)
{
  std::cout << "\nmain Begin\n";
  
  // Create and initialize the state machine
  SM_StateController stateMachine;
  
  stateMachine.initialize();
  
  // Exercise the state machine by sending a variety of events to it.
  stateMachine.triggerEvent(SM_EVENT_BatteryOn);

  stateMachine.triggerEvent(SM_EVENT_RemoteArm);
  
  stateMachine.triggerEvent(SM_EVENT_RemoteUnarm);
  
  stateMachine.triggerEvent(SM_EVENT_DoorsOpen);
  
  stateMachine.triggerEvent(SM_EVENT_RemoteArm);
  
  stateMachine.triggerEvent(SM_EVENT_RemoteUnarm);
  
  stateMachine.triggerEvent(SM_EVENT_UnarmTimerExpired);
  
  std::cout << "main End\n\n";
}