//-------------------------------------------------------------------------
//
// File Name: sm_stateController.cpp
//
// Copyright (c) 2007-2008, Jason Breti (http://breti.org/codegen)
// All rights reserved.
// This code is released under the BSD License, as specified in the
// license.txt file.
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
#include "sm_stateController.h"        // class SM_StateController
#include "sm_state.h"                  // class SM_State

//-------------------------------------------------------------------------
//
// Class Name : SM_StateController
//
//-------------------------------------------------------------------------

SM_StateController::SM_StateController ()
{}

//-------------------------------------------------------------------------
SM_StateController::~SM_StateController ()
{}

//-------------------------------------------------------------------------
void SM_StateController::initialize ()
{
  SM_State* initialStatePtr = m_stateChart.initialize();
  
  // Once all the states have been initialized then transition into the
  // initial state
  if (initialStatePtr != 0)
  {
    initialStatePtr->onentry();
  }
}

//-------------------------------------------------------------------------
void SM_StateController::triggerEvent (enum SM_EVENTS event)
{
  SM_State* nextStatePtr = 0;
  
  if (m_stateChart.transitionState(event, nextStatePtr))
  {
    nextStatePtr->onentry();
  }

}

//-------------------------------------------------------------------------
